#include <Xm/Xm.h>
#include <Xm/FileSB.h>
#include <Xm/MessageB.h>
#include <Xm/ToggleBG.h>
#include <Xm/List.h>
#include <X11/cursorfont.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <fstream.h>
#include <linux/errno.h>
#include "nrutil.h"
#include "global.h"

void f_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget        toplevel;
  int           item, n;
  Arg           args[5];
  static Widget fsb_ls, fsb_ss, fsb_sd, ft_sd, needsave;
  XmStringTable str_list;

  void ls_cb(Widget, XtPointer, XtPointer);
  void ss_cb(Widget, XtPointer, XtPointer);
  void sd_cb(Widget, XtPointer, XtPointer);
  void quit_cb(Widget, XtPointer, XtPointer);
  void fsb_cancel(Widget, XtPointer, XtPointer);
  
  toplevel=XtParent(widget);
  while (!XtIsTopLevelShell(toplevel)) toplevel=XtParent(toplevel);

  item=(int) client_data;
  switch(item) {
  case 0:      // load setup;
    if (!fsb_ls) {
      fsb_ls=XmCreateFileSelectionDialog(toplevel, "filesb", NULL, 0);
      XtAddCallback(fsb_ls,XmNokCallback, ls_cb, NULL);
      XtAddCallback(fsb_ls,XmNcancelCallback, fsb_cancel, NULL);
      XtVaSetValues(XtParent(fsb_ls),
		    XmNtitle, "Load Setup",
		    NULL);
    }
    XtManageChild(fsb_ls);
    break;
  case 1:      // save setup;
    if (!fsb_ss) {
      fsb_ss=XmCreateFileSelectionDialog(toplevel, "filesb", NULL, 0);
      XtAddCallback(fsb_ss,XmNokCallback, ss_cb, NULL);
      XtAddCallback(fsb_ss,XmNcancelCallback, fsb_cancel, NULL);
      XtVaSetValues(XtParent(fsb_ss),
		    XmNtitle, "Save Setup",
		    NULL);
    }
    XtManageChild(fsb_ss);
    break;
  case 2:      // save data;
    if (!fsb_sd) {
      fsb_sd=XmCreateFileSelectionDialog(toplevel, "filesb", NULL, 0);
      XtVaSetValues(XtParent(fsb_sd),
		    XmNtitle, "Save Data",
		    NULL);
      str_list=(XmStringTable) XtMalloc(3*sizeof(XmString));
      str_list[0]=XmStringCreateLocalized("ASCII");
      str_list[1]=XmStringCreateLocalized("TSA");
      str_list[2]=XmStringCreateLocalized("MAD");
      ft_sd=XmCreateScrolledList(fsb_sd, "filetype", NULL, 0);
      XtVaSetValues(ft_sd,
		    XmNselectionPolicy, XmSINGLE_SELECT,
		    XmNvisibleItemCount, 2,
		    XmNitemCount, 3,
		    XmNitems, str_list,
		    NULL);
      XmListSelectPos(ft_sd, 1, True);
      XtAddCallback(fsb_sd,XmNokCallback, sd_cb, NULL);
      XtAddCallback(fsb_sd,XmNcancelCallback, fsb_cancel, NULL);
      XtVaSetValues(fsb_sd, XmNuserData, ft_sd, NULL);
      XtFree((char *)str_list);
    }
    XtManageChild(ft_sd);
    XtManageChild(fsb_sd);
    break;
  case 3:      // quit;
    if (!reg.recon) {
      if (reg.needsave) {
	if (!needsave) {
	  n=0;
	  XtSetArg(args[n], XmNmessageString, XmStringCreateLtoR("      Data not saved!\nDo you really want to quit?", XmFONTLIST_DEFAULT_TAG)); n++;
	  XtSetArg(args[n], XmNokLabelString, XmStringCreateLocalized(" Yes ")); n++;
	  XtSetArg(args[n], XmNcancelLabelString, XmStringCreateLocalized(" No ")); n++;
	  XtSetArg(args[n], XmNtitle, "Really Quit ?"); n++;
	  needsave=XmCreateQuestionDialog(toplevel, "savedata", args, n);
	  XtAddCallback(needsave, XmNokCallback, quit_cb, NULL);
	  XtUnmanageChild(XmMessageBoxGetChild(needsave, XmDIALOG_HELP_BUTTON));
	}
	XtManageChild(needsave);
	XtPopup(XtParent(needsave), XtGrabNone);
      }
      else {
	exit(0);
      }
    }
    break;
  }
}

/* ..................................*/
/* .....   C a l l b a c k s   ..... */
/* ................................. */

void ls_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  int           i, j, k;
  float         ver;
  char          *filename, c, s[20];
  Cursor        uhr, pfeil;
  ifstream      dat;
  
  extern void clearscreen(Window window);
  extern void analog_manage_widgets();

  XmFileSelectionBoxCallbackStruct *cbs=
    (XmFileSelectionBoxCallbackStruct *) call_data;

  if (!XmStringGetLtoR(cbs->value, XmFONTLIST_DEFAULT_TAG, &filename)) {
    cout << "Internal error pasting filename! \n";
    return;
  }
  if (!*filename) {
    cout << "No file selected! \n";
    XtFree(filename);
    return;
  }

  uhr  =XCreateFontCursor(XtDisplay(widget),XC_watch);
  pfeil=XCreateFontCursor(XtDisplay(widget), XC_arrow);

  XDefineCursor(XtDisplay(widget),XtWindow(widget),uhr);
  XFlush(XtDisplay(widget));

  /* E i n g a b e d a t e i   l e s e n   */
  dat.open(filename);
  if (!dat) {
    cout << "Cannot open file \n";
    return;
  }
  /* zuerst allgemeine Daten */
  dat >> ver;
  if (ver>0) {
    reg.sr=(int)ver;
    ver=1.5;
  }
  else ver*=(-1);
  if (ver>1.5) dat >> reg.sr;
  dat >> reg.length;
  if (ver>=3.0) dat >> reg.analog;
  /* danach Daten fr alle 8 Kanle */
  reg.nactive=0; der.nactive=0;
  for (i=0; i<8; i++) {
    dat >> j;
    dat >> ch[i].active;
    if (ch[i].active) {
      reg.nactive++;
      XtSetSensitive(mymenu.calibrate.channel[i],True);
    }
    else XtSetSensitive(mymenu.calibrate.channel[i],False);
    if (ver>1.5) dat >> ch[i].polarity;
    dat >> ch[i].color;
    dat >> ch[i].height;
    dat >> j;
    dat >> ch[i].cal.ad_low;
    dat >> ch[i].cal.ad_high;
    dat >> ch[i].cal.rw_low;
    dat >> ch[i].cal.rw_high;
    if (ver>2.2) {
      dat >> j;
      dat >> dch[i].threshold;
      dat >> dch[i].movavg;
      dch[i].mavg=(int *)realloc(dch[i].mavg, dch[i].movavg*sizeof(int));
      dch[i].masum=0;
      dat >> dch[i].ampli;
      dch[i].nch=0;
      for (k=0; k<7; k++) {
	dat >> j; dat >> j;
	dat >> dch[i].ch[k].active;
	if (dch[i].ch[k].active) {
	  dch[i].nch++;
	  XtSetSensitive(mymenu.calibrate.channel[i],True);
	}
	dat >> dch[i].ch[k].color;
	dat >> dch[i].ch[k].height;
	dat >> j; dat >> j;
	dat >> dch[i].ch[k].cal.ad_low;
	dat >> dch[i].ch[k].cal.ad_high;
	dat >> dch[i].ch[k].cal.rw_low;
	dat >> dch[i].ch[k].cal.rw_high;
      }
      if (dch[i].nch>0) der.nactive++;
    }
  }
  reg.nbuf = reg.length*reg.sr/reg.xpix;
  if (reg.nbuf<1) {
    reg.nbuf=1;
    reg.length=reg.nbuf*reg.xpix/reg.sr;
  }
  sprintf(s,"%d", reg.length);
  XtVaSetValues(trace_label,
		XtVaTypedArg, XmNlabelString, XmRString, s, strlen(s)+1,
		NULL);
  sprintf(s,"%d", reg.sr);
  XtVaSetValues(sr_label,
		XtVaTypedArg, XmNlabelString, XmRString, s, strlen(s)+1,
		NULL);

  if (analog_w) {
    XtPopdown(analog_w);
    XtDestroyWidget(analog_w);
  }
  analog_manage_widgets();
  if (reg.analog) {
    reg.analog=0;
    XmToggleButtonGadgetSetState(mymenu.options.analog, False, False);
    XmToggleButtonGadgetSetState(mymenu.options.analog, True, True);
  }
  else {
    reg.analog=1;
    XmToggleButtonGadgetSetState(mymenu.options.analog, True, False);
    XmToggleButtonGadgetSetState(mymenu.options.analog, False, True);
  }
  
  dat.close();
  XtFree(filename);
  XDefineCursor(XtDisplay(widget),XtWindow(widget),pfeil);
  XtUnmanageChild(widget);
  XFreeCursor(XtDisplay(widget), pfeil);
  XFreeCursor(XtDisplay(widget), uhr);
  if ((reg.nactive+der.nactive) > 0) XtSetSensitive(mymenu.recording.s_recording, True);
  clearscreen(XtWindow(drawing_a));
  return;
}

void ss_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  int           i, n;
  Arg           args[5];
  static Widget fexist;
  char          *filename;
  ofstream      dat;
  extern int    errno;
  void write_setup(char *, Widget);
  void over_setup(Widget, XtPointer, XtPointer);

  XmFileSelectionBoxCallbackStruct *cbs= 
    (XmFileSelectionBoxCallbackStruct *) call_data;
  if (!XmStringGetLtoR(cbs->value, XmFONTLIST_DEFAULT_TAG, &filename)) {
    cout << "Internal error pasting filename! \n";
    return;
  }
  if (!*filename) {
    cout << "No file selected! \n";
    XtFree(filename);
    return;
  }
  dat.open(filename, ios::noreplace);
  if (errno==EEXIST) {
    if (!fexist) {
      n=0;
      XtSetArg(args[n], XmNmessageString, XmStringCreateLtoR("File already exists.\n     Overwrite?",XmFONTLIST_DEFAULT_TAG)); n++;
      XtSetArg(args[n], XmNokLabelString, XmStringCreateLocalized(" Yes ")); n++;
      XtSetArg(args[n], XmNcancelLabelString, XmStringCreateLocalized(" No ")); n++;
      XtSetArg(args[n], XmNtitle, "Save Setup"); n++;
      fexist=XmCreateQuestionDialog(widget, "fexist", args, n);
      XtAddCallback(fexist, XmNokCallback, over_setup, widget);
      XtUnmanageChild(XmMessageBoxGetChild(fexist, XmDIALOG_HELP_BUTTON));
    }
    XtManageChild(fexist);
    XtPopup(XtParent(fexist), XtGrabNone);
  }
  if (dat) {
    dat.close();
    write_setup(filename, widget);
  }
  XtFree(filename);
  return;
}

void sd_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  char          *filename;
  ofstream      dat;
  int           n;
  Arg           args[5];
  static Widget fexist;
  extern int    errno;
  void          write_data(char *, Widget);
  void          over_data(Widget, XtPointer, XtPointer);

  XmFileSelectionBoxCallbackStruct *cbs=
    (XmFileSelectionBoxCallbackStruct *) call_data;
  if (!XmStringGetLtoR(cbs->value, XmFONTLIST_DEFAULT_TAG, &filename)) {
    cout << "Internal error pasting filename! \n";
    return;
  }
  if (!*filename) {
    cout << "No file selected! \n";
    XtFree(filename);
    return;
  }

  /* check whether file exists */
  dat.open(filename, ios::noreplace);
  if (errno==EEXIST) {
    if (!fexist) {
      n=0;
      XtSetArg(args[n], XmNmessageString, XmStringCreateLtoR("File already exists.\n     Overwrite?",XmFONTLIST_DEFAULT_TAG)); n++;
      XtSetArg(args[n], XmNokLabelString, XmStringCreateLocalized(" Yes ")); n++;
      XtSetArg(args[n], XmNcancelLabelString, XmStringCreateLocalized(" No ")); n++;
      XtSetArg(args[n], XmNtitle, "Save Data"); n++;
      fexist=XmCreateQuestionDialog(widget, "fexist", args, n);
      XtAddCallback(fexist, XmNokCallback, over_data, widget);
      XtUnmanageChild(XmMessageBoxGetChild(fexist, XmDIALOG_HELP_BUTTON));
    }
    XtManageChild(fexist);
    XtPopup(XtParent(fexist), XtGrabNone);
  }
  if (dat) {
    dat.close();
    write_data(filename, widget);
  }

  XtFree(filename);
  return;
}

void quit_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  exit(0);
}

void fsb_cancel(Widget widget, XtPointer client_data, XtPointer call_data) {
  XtUnmanageChild(widget);
}


void write_setup(char *filename, Widget widget) {
  Cursor        uhr, pfeil;
  ofstream      dat;
  int           i, j;

  /* A u s g a b e d a t e i   s c h r e i b e n   */
  // cursor setzen;
  uhr  =XCreateFontCursor(XtDisplay(widget),XC_watch);
  pfeil=XCreateFontCursor(XtDisplay(widget), XC_arrow);
  XDefineCursor(XtDisplay(widget),XtWindow(widget),uhr);
  XFlush(XtDisplay(widget));

  // Open File;
  dat.open(filename);
  if (!dat) {
    cout << "Cannot open file for output \n";
    return;
  }

  /* zuerst allgemeine Daten */
  dat << -atof(VERSION) << "\t" << reg.sr << "\t" << reg.length << "\t";
  /* in Version 3.0 added reg.analog */
  dat << reg.analog << "\n";
  /* danach Daten fr alle 8 Kanle */
  for (i=0; i<8; i++)  {
    // direct channel;
    dat << i << "\t" << ch[i].active << "\t" << ch[i].polarity << "\t"
	<< ch[i].color << "\t" << ch[i].height << "\n";
    dat << i << "\t" << ch[i].cal.ad_low << "\t" << ch[i].cal.ad_high << "\t"
                     << ch[i].cal.rw_low << "\t" << ch[i].cal.rw_high << "\n";
    // derived channels;
    dat << i << "\t" << dch[i].threshold << "\t" << dch[i].movavg << "\t" << dch[i].ampli << "\n";
    for (j=0; j<7; j++) {
      dat << i << "\t" << j << "\t" << dch[i].ch[j].active << "\t"
	  << dch[i].ch[j].color << "\t" << dch[i].ch[j].height << "\n";
      dat << i << "\t" << j << "\t" << dch[i].ch[j].cal.ad_low << "\t" << dch[i].ch[j].cal.ad_high << "\t"
	  << dch[i].ch[j].cal.rw_low << "\t" << dch[i].ch[j].cal.rw_high << "\n";
    }
  }
  dat.close();
  XDefineCursor(XtDisplay(widget),XtWindow(widget),pfeil);
  XtUnmanageChild(widget);
  XFreeCursor(XtDisplay(widget), pfeil);
  XFreeCursor(XtDisplay(widget), uhr);
  return;
}


void over_setup(Widget w, XtPointer client_data, XtPointer call_data) {

  XmString fname;
  char     *filename;
  XtVaGetValues((Widget)client_data, XmNdirSpec, &fname, NULL);
  XmStringGetLtoR(fname, XmFONTLIST_DEFAULT_TAG, &filename);
  write_setup(filename, (Widget)client_data);
  XmStringFree(fname);
  XtFree(filename);
}

void write_data(char *filename, Widget widget) {
  Widget        fsb_sd, ft_sd;
  Cursor        uhr, pfeil;
  int           i, j, k, isactive, *wert;
  int           *pos_list, pos_cnt;
  int           nch;
  int           fwidth;
  unsigned long *ndata, nlines, n;
  float         m[8], b[8], cumtime, realwert;
  float         *xdat, *ydat, *y2, starttime, xtime;
  char          *fname, command[256];
  ofstream      dat, outder[8];
  ifstream      in[8], inder[8];
  FILE          *temp_file;

  extern void splint(float xa[], float ya[] ,float y2a[] , unsigned long n, float x, float *y);
  extern void spline(float x[], float y[], unsigned long n, float yp1, float ypn, float y2[]);
  uhr  =XCreateFontCursor(XtDisplay(widget),XC_watch);
  pfeil=XCreateFontCursor(XtDisplay(widget), XC_arrow);
  XDefineCursor(XtDisplay(widget),XtWindow(widget),uhr);
  XFlush(XtDisplay(widget));

  /* get filetype 1: ASCII, 2: TSA, 3: MAD */
  /* returned in pos_list[0]               */
  fsb_sd=widget;
  XtVaGetValues(fsb_sd, XmNuserData, &ft_sd, NULL);
  XmListGetSelectedPos(ft_sd,&pos_list,&pos_cnt);
  
  wert  = new int;
  ndata = new unsigned long;
  fname = new char [100];

  // write the different file formats;
  switch(pos_list[0]) {
  case 1: // ASCII file;
    // open input files: out.i, derout.i;
    isactive=-1; /* first active direct channel */
    for (i=0; i<8; i++) {
      if (ch[i].active && isactive==(-1)) isactive=i;
      sprintf(fname, DIRECTDAT".%d", i);
      in[i].open(fname, ios::in | ios::bin);
      sprintf(fname, DERIVEDDAT".%d", i);
      inder[i].open(fname, ios::in | ios::bin);
    }
    // open output files;
    dat.open(filename);
    if (!dat) {
      cout << "Cannot open file \n";
      return;
    }
    for (i=0; i<8; i++) {
      if (dch[i].nch>0) {
	sprintf(fname, "%s.%d", filename,i);
	outder[i].open(fname);
	if (!outder[i]) {
	  cout << "Cannot open file " << fname << "\n";
	  return;
	}
      }
    }
    // write direkt data;
    for (i=0; i<8; i++) {
      if (ch[i].active) {
	m[i]=(ch[i].cal.rw_high-ch[i].cal.rw_low)/(ch[i].cal.ad_high-ch[i].cal.ad_low);
	b[i]=ch[i].cal.rw_high-(m[i]*ch[i].cal.ad_high);
      }
    }
    if (isactive>=0) {
      *wert=0;
      while(!in[isactive].eof()) {
	for (i=0; i<8; i++) {
	  if (ch[i].active) {
	    in[i].read((unsigned char *)wert, 2);
	    dat << m[i] * (float)(*wert) + b[i] << "\t";
	  }
	}
	dat << "\n";
      }
    }
    // write derived data;
    *wert=0;
    for (i=0; i<8; i++) {
      if (dch[i].nch>0) {
	cumtime=0;
	while (!inder[i].eof()) {
	  inder[i].read((unsigned char *)ndata, sizeof(unsigned long));
	  cumtime+=(float)(*ndata)/reg.sr;
	  fwidth=outder[i].width(10);
	  outder[i] << cumtime;
	  outder[i].width(fwidth);
	  for (j=0; j<7; j++) {
	    if (dch[i].ch[j].active) {
	      m[j]=(dch[i].ch[j].cal.rw_high-dch[i].ch[j].cal.rw_low)/
		(dch[i].ch[j].cal.ad_high-dch[i].ch[j].cal.ad_low);
	      b[j]=dch[i].ch[j].cal.rw_high-(m[j]*dch[i].ch[j].cal.ad_high);
	      inder[i].read((unsigned char *)wert, 2);
	      outder[i] << "\t" << m[j] * (float)(*wert) + b[i];
	    }
	  }
	  outder[i] << "\n";
	}
      }
    }
    /* close input files */
    for (i=0; i<8; i++) {
      in[i].close();
      inder[i].close();
    }
    /* close output files */
    for (i=0; i<8; i++) if (dch[i].nch>0) outder[i].close();
    dat.close();
    reg.needsave=0;
    break;
  case 2: // TSA file;
    // open output file;
    dat.open(filename);
    if (!dat) {
      cout << "Cannot open file \n";
      return;
    }
    // write header as text;
    nch=0;
    for (i=0; i<8; i++) nch+=dch[i].nch;
    dat << reg.nactive+nch << "\n"; /* number of channels */
    dat << "name\t" << "unit\t" << "sr\t" << "n\t" << "resolution \n";
    for (i=0; i<8; i++)  {
      if (ch[i].active) {
	/* get number of data values */
	sprintf(fname, DIRECTDAT".%d", i);
	temp_file=fopen(fname, "r");
	fseek(temp_file,0,SEEK_END);
	*ndata=ftell(temp_file)/2;
	fclose(temp_file);
	dat << "?" << "\t" << "?" << "\t" << reg.sr << "\t" 
	    << *ndata << "\t" << sizeof(float) << "\n";
      }
      if (dch[i].nch>0) {
	/* get number of data values */
	sprintf(fname, DERIVEDDAT".%d", i);
	temp_file=fopen(fname, "rb");
	fseek(temp_file,0,SEEK_END);
	nlines=ftell(temp_file)/(sizeof(unsigned long)+(2*dch[i].nch));
	if (nlines>1) {
	  cumtime=0;
	  for (n=1; n<nlines; n++) {
	    fseek(temp_file, n*(sizeof(unsigned long)+(2*dch[i].nch)), SEEK_SET);
	    fread((unsigned char *)ndata, sizeof(unsigned long), 1, temp_file);
	    cumtime+=(float)(*ndata)/reg.sr;
	  }
	  fclose(temp_file);
	  for (j=0; j<7; j++) {
	    if (dch[i].ch[j].active) {
	      switch (j) {
	      case 0:
		dat << "frequency" << "\t" << "Hz" << "\t" << (float)(nlines-1)/cumtime << "\t" 
		    << nlines-1 << "\t" << sizeof(float) << "\n";
		break;
	      case 1:
		dat << "maximum" << "\t" << "?" << "\t" << (float)(nlines-1)/cumtime << "\t" 
		    << nlines-1 << "\t" << sizeof(float) << "\n";
		break;
	      case 2:
		dat << "mean" << "\t" << "?" << "\t" << (float)(nlines-1)/cumtime << "\t" 
		    << nlines-1 << "\t" << sizeof(float) << "\n";
		break;
	      case 3:
		dat << "minimum" << "\t" << "?" << "\t" << (float)(nlines-1)/cumtime << "\t" 
		    << nlines-1 << "\t" << sizeof(float) << "\n";
		break;
	      case 4:
		dat << "amplitude" << "\t" << "?" << "\t" << (float)(nlines-1)/cumtime << "\t" 
		    << nlines-1 << "\t" << sizeof(float) << "\n";
		break;
	      case 5:
		dat << "dy/dtmin" << "\t" << "?" << "\t" << (float)(nlines-1)/cumtime << "\t" 
		    << nlines-1 << "\t" << sizeof(float) << "\n";
		break;
	      case 6:
		dat << "dy/dtmax" << "\t" << "?" << "\t" << (float)(nlines-1)/cumtime << "\t" 
		    << nlines-1 << "\t" << sizeof(float) << "\n";
		break;
	      }
	    }
	  }
	}
      }
    }
    dat.close();
    // write data as binary;
    dat.open(filename, ios::bin | ios::app,0);
    for (i=0; i<8; i++) {
      /* write direct channel */
      if (ch[i].active) {
	m[i]=(ch[i].cal.rw_high-ch[i].cal.rw_low)/(ch[i].cal.ad_high-ch[i].cal.ad_low);
	b[i]=ch[i].cal.rw_high-(m[i]*ch[i].cal.ad_high);
	sprintf(fname, DIRECTDAT".%d", i);
	temp_file=fopen(fname, "rb");
	fseek(temp_file,0,SEEK_END);
	*ndata=ftell(temp_file)/2;
	fclose(temp_file);
	in[i].open(fname, ios::in | ios::bin);
	*wert=0;
	for (n=0; n<(*ndata); n++) {
	  in[i].read((unsigned char *)wert, 2);
	  realwert=b[i]+m[i]*(float)(*wert);
	  dat.write((unsigned char *)&realwert, sizeof(float));
	}
	in[i].close();
      }
      /* write derived channels */
      if (dch[i].nch>0) {
	sprintf(fname, DERIVEDDAT".%d", i);
	temp_file=fopen(fname, "rb");
	fseek(temp_file,0,SEEK_END);
	nlines=ftell(temp_file)/(sizeof(unsigned long)+(2*dch[i].nch));
	fclose(temp_file);
	xdat=new float[nlines-1];
	ydat=new float[nlines-1];
	y2=new float[nlines-1];
	inder[i].open(fname, ios::in | ios::bin);
	for (j=0; j<7; j++) {
	  if (dch[i].ch[j].active) {
	    if (nlines>1) {
	      m[j]=(dch[i].ch[j].cal.rw_high-dch[i].ch[j].cal.rw_low)/
       		   (dch[i].ch[j].cal.ad_high-dch[i].ch[j].cal.ad_low);
	      b[j]=dch[i].ch[j].cal.rw_high-(m[j]*dch[i].ch[j].cal.ad_high);
	      cumtime=0;
	      inder[i].seekg(0,ios::beg);
	      for (n=0; n<nlines; n++) {
		inder[i].read((unsigned char *)ndata, sizeof(unsigned long));
		if (n==0) starttime=(float)(*ndata/reg.sr);
		cumtime+=(float)(*ndata)/reg.sr;
		for (k=0; k<=j; k++)
		  if (dch[i].ch[k].active) inder[i].read((unsigned char *)wert, 2);
		realwert=b[j]+m[j]*(float)(*wert);
		if (n>0) {
		  xdat[n-1]=cumtime;
		  ydat[n-1]=realwert;
		}
		for (k=j+1; k<7; k++)
		  if (dch[i].ch[k].active) inder[i].read((unsigned char *)wert, 2);
	      }
	      spline(xdat-1, ydat-1, nlines-1, 1e30, 1e30, y2-1);
	      xtime=starttime;
	      for (n=0; n<(nlines-1); n++) {
		splint(xdat-1, ydat-1, y2-1, nlines-1, xtime, &realwert);
		dat.write((unsigned char *)&realwert, sizeof(float));
		xtime+=(cumtime-starttime)/(nlines-2);
	      }
	    }
	  }
	}
	inder[i].close();
	delete[]xdat; delete[]ydat; delete[]y2;
      }
    }
    reg.needsave=0;
    dat.close();
    break;
  case 3: // MAD file;
    /* get number of channels */
    nch=0;
    for (i=0; i<8; i++) nch+=dch[i].nch;
    nch+=reg.nactive;
    /* open output file */
    dat.open(filename);
    if (!dat) {
      cout << "Cannot open file \n";
      return;
    }
    /* write identifier and nch */
    dat << "MAD" << VERSION << "\t" << nch << "\n";
    /* write setup part */
    dat << "ndata\tsr\tcolor\theight\n";
    for (i=0; i<8; i++)  {
      // direct channel;
      if (ch[i].active) {
	/* get number of data values */
	sprintf(fname, DIRECTDAT".%d", i);
	temp_file=fopen(fname, "rb");
	fseek(temp_file,0,SEEK_END);
	*ndata=ftell(temp_file)/2;
	fclose(temp_file);
	dat << *ndata << "\t" << reg.sr << "\t";
	dat << ch[i].color << "\t" << ch[i].height << "\n";
      }
      // derived channels;
      for (j=0; j<7; j++) {
	if (dch[i].ch[j].active) {
	  /* get number of data values */
	  sprintf(fname, DERIVEDDAT".%d", i);
	  temp_file=fopen(fname, "rb");
	  fseek(temp_file,0,SEEK_END);
	  nlines=ftell(temp_file)/(sizeof(unsigned long)+(2*dch[i].nch));
	  if (nlines>1) {
	    cumtime=0;
	    for (n=1; n<nlines; n++) {
	      fseek(temp_file, n*(sizeof(unsigned long)+(2*dch[i].nch)), SEEK_SET);
	      fread((unsigned char *)ndata, sizeof(unsigned long), 1, temp_file);
	      cumtime+=(float)(*ndata)/reg.sr;
	    }
	  }
	  fclose(temp_file);
	  dat << (nlines-1) << "\t" << (float)(nlines-1)/cumtime << "\t";
	  dat << dch[i].ch[j].color << "\t" << dch[i].ch[j].height << "\n";
	}
      }
    }
    dat.close();
    /* write comments part */
    sprintf(command, "cat %s >> %s", COMMENTDAT, filename);
    system(command);
    /* write data as binary */
    dat.open(filename, ios::app | ios::out,0);
    dat << "data\n";
    dat.close();
    dat.open(filename, ios::bin | ios::app,0);
    for (i=0; i<8; i++) {
      /* write direct channel */
      if (ch[i].active) {
	m[i]=(ch[i].cal.rw_high-ch[i].cal.rw_low)/(ch[i].cal.ad_high-ch[i].cal.ad_low);
	b[i]=ch[i].cal.rw_high-(m[i]*ch[i].cal.ad_high);
	sprintf(fname, DIRECTDAT".%d", i);
	temp_file=fopen(fname, "rb");
	fseek(temp_file,0,SEEK_END);
	*ndata=ftell(temp_file)/2;
	fclose(temp_file);
	in[i].open(fname, ios::in | ios::bin);
	*wert=0;
	for (n=0; n<(*ndata); n++) {
	  in[i].read((unsigned char *)wert, 2);
	  realwert=b[i]+m[i]*(float)(*wert);
	  dat.write((unsigned char *)&realwert, sizeof(float));
	}
	in[i].close();
      }
      /* write derived channels */
      if (dch[i].nch>0) {
	sprintf(fname, DERIVEDDAT".%d", i);
	temp_file=fopen(fname, "rb");
	fseek(temp_file,0,SEEK_END);
	nlines=ftell(temp_file)/(sizeof(unsigned long)+(2*dch[i].nch));
	fclose(temp_file);
	xdat=new float[nlines-1];
	ydat=new float[nlines-1];
	y2=new float[nlines-1];
	inder[i].open(fname, ios::in | ios::bin);
	for (j=0; j<7; j++) {
	  if (dch[i].ch[j].active) {
	    if (nlines>1) {
	      m[j]=(dch[i].ch[j].cal.rw_high-dch[i].ch[j].cal.rw_low)/
       		   (dch[i].ch[j].cal.ad_high-dch[i].ch[j].cal.ad_low);
	      b[j]=dch[i].ch[j].cal.rw_high-(m[j]*dch[i].ch[j].cal.ad_high);
	      cumtime=0;
	      inder[i].seekg(0,ios::beg);
	      for (n=0; n<nlines; n++) {
		inder[i].read((unsigned char *)ndata, sizeof(unsigned long));
		if (n==0) starttime=(float)(*ndata/reg.sr);
		cumtime+=(float)(*ndata)/reg.sr;
		for (k=0; k<=j; k++)
		  if (dch[i].ch[k].active) inder[i].read((unsigned char *)wert, 2);
		realwert=b[j]+m[j]*(float)(*wert);
		if (n>0) {
		  xdat[n-1]=cumtime;
		  ydat[n-1]=realwert;
		}
		for (k=j+1; k<7; k++)
		  if (dch[i].ch[k].active) inder[i].read((unsigned char *)wert, 2);
	      }
	      spline(xdat-1, ydat-1, nlines-1, 1e30, 1e30, y2-1);
	      xtime=starttime;
	      for (n=0; n<(nlines-1); n++) {
		splint(xdat-1, ydat-1, y2-1, nlines-1, xtime, &realwert);
		dat.write((unsigned char *)&realwert, sizeof(float));
		xtime+=(cumtime-starttime)/(nlines-2);
	      }
	    }
	  }
	}
	inder[i].close();
	delete[]xdat; delete[]ydat; delete[]y2;
      }
    }
    reg.needsave=0;
    dat.close();
    break;
  } /* end switch: save different file formats */

  delete wert; delete ndata; delete[]fname;
  XDefineCursor(XtDisplay(widget),XtWindow(widget),pfeil);
  XtUnmanageChild(widget);
  XtFree((char *)pos_list);
  XFreeCursor(XtDisplay(widget), pfeil);
  XFreeCursor(XtDisplay(widget), uhr);
  return;
}

void over_data(Widget w, XtPointer client_data, XtPointer call_data) {
  XmString fname;
  char     *filename;

  XtVaGetValues((Widget)client_data, XmNdirSpec, &fname, NULL);
  XmStringGetLtoR(fname, XmFONTLIST_DEFAULT_TAG, &filename);
  write_data(filename, (Widget)client_data);
  XmStringFree(fname);
  XtFree(filename);
}
